
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Cuboctahedron()
{
    FILE *fp;
    extern char *filename;
    extern char creatingObject;
    creatingObject = 0;

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 20 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "cuboctahedron.geom" );
    fp = fopen( filename, "w" );

    fprintf( fp, "13\t14\t49\n" );

    /* Print the Coordinates of the points */
    fprintf( fp, " 0.000000  1.000000  1.000000\n" );
    fprintf( fp, " 1.000000  0.000000  1.000000\n" );
    fprintf( fp, " 0.000000 -1.000000  1.000000\n" );
    fprintf( fp, " 1.000000  1.000000  0.000000\n" );
    fprintf( fp, "-1.000000  1.000000  0.000000\n" );
    fprintf( fp, " 0.000000 -1.000000 -1.000000\n" );
    fprintf( fp, "-1.000000 -0.500000 -0.500000\n" );
    fprintf( fp, "-1.000000  0.000000 -1.000000\n" );
    fprintf( fp, "-1.000000 -1.000000  0.000000\n" );
    fprintf( fp, " 1.000000  0.000000 -1.000000\n" );
    fprintf( fp, "-1.000000  0.000000  1.000000\n" );
    fprintf( fp, " 1.000000 -1.000000  0.000000\n" );
    fprintf( fp, " 0.000000  1.000000 -1.000000\n" );

    /* Print the Conectivity data of the points */
    fprintf( fp, "3 1 3 0\n" );
    fprintf( fp, "4 0 10 2 1\n" );
    fprintf( fp, "3 10 0 4\n" );
    fprintf( fp, "5 4 7 6 8 10\n" );
    fprintf( fp, "3 4 12 7\n" );
    fprintf( fp, "4 3 12 4 0\n" );
    fprintf( fp, "3 10 8 2\n" );
    fprintf( fp, "3 7 5 8\n" );
    fprintf( fp, "4 9 3 1 11\n" );
    fprintf( fp, "3 9 12 3\n" );
    fprintf( fp, "3 11 1 2\n" );
    fprintf( fp, "4 5 11 2 8\n" );
    fprintf( fp, "4 12 9 5 7\n" );
    fprintf( fp, "3 9 11 5\n" );

    fclose( fp );

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 20 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "cuboctahedron.aoff" );
    fp = fopen( filename, "w" );

    fprintf( fp, "geometry\tindexed_poly\tfff\t\t%s\n", "cuboctahedron.geom" );
    fprintf( fp, "connect_offset\tdefault\t\tf\t\t0\n" );

    fclose( fp );
}
